diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
new file mode 100644
index 000000000..3813cb851
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
@@ -0,0 +1,120 @@
+package net.minecraft.core.current.wire;
+
+import net.minecraft.core.current.util.BlockPos;
+import net.minecraft.core.current.util.BlockState;
+import net.minecraft.core.current.util.Mth;
+import net.minecraft.core.current.util.Redstone;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+
+/**
+ * A WireNode is a Node that represents a wire in the world. It stores all the
+ * information about the wire that the WireHandler needs to calculate power
+ * changes.
+ *
+ * @author Space Walker
+ */
+public class WireNode extends Node {
+
+	final WireConnectionManager connections;
+
+	/** The power level this wire currently holds in the world. */
+	int currentPower;
+	/**
+	 * While calculating power changes for a network, this field is used to keep
+	 * track of the power level this wire should have.
+	 */
+	int virtualPower;
+	/** The power level received from non-wire components. */
+	int externalPower;
+	/**
+	 * A 4-bit number that keeps track of the power flow of the wires that give this
+	 * wire its power level.
+	 */
+	int flowIn;
+	/** The direction of power flow, based on the incoming flow. */
+	int iFlowDir;
+	boolean added;
+	boolean removed;
+	boolean shouldBreak;
+	boolean root;
+	boolean discovered;
+	boolean searched;
+
+	/** The next wire in the simple queue. */
+	WireNode next_wire;
+
+	WireNode(World world, BlockPos pos, BlockState state) {
+		super(world);
+
+		this.pos = pos;
+		this.state = state;
+
+		this.connections = new WireConnectionManager(this);
+
+		this.virtualPower = this.currentPower = this.state.get();
+		this.priority = priority();
+	}
+
+	@Override
+	Node set(BlockPos pos, BlockState state, boolean clearNeighbors) {
+		throw new UnsupportedOperationException("Cannot update a WireNode!");
+	}
+
+	@Override
+	int priority() {
+		return Mth.clamp(virtualPower, Redstone.SIGNAL_MIN, Redstone.SIGNAL_MAX);
+	}
+
+	@Override
+	public boolean isWire() {
+		return true;
+	}
+
+	@Override
+	public WireNode asWire() {
+		return this;
+	}
+
+	boolean offerPower(int power, int iDir) {
+		if (removed || shouldBreak) {
+			return false;
+		}
+		if (power == virtualPower) {
+			flowIn |= (1 << iDir);
+			return false;
+		}
+		if (power > virtualPower) {
+			virtualPower = power;
+			flowIn = (1 << iDir);
+
+			return true;
+		}
+
+		return false;
+	}
+
+	boolean setPower() {
+		if (removed) {
+			return true;
+		}
+
+		state = WorldHelper.getBlockState(world, pos);
+
+		if (!state.is(Blocks.WIRE_REDSTONE)) {
+			return false; // we should never get here
+		}
+
+		if (shouldBreak) {
+			state.dropItems(world, pos);
+			world.setBlock(pos.x, pos.y, pos.z, 0);
+
+			return true;
+		}
+
+		currentPower = Mth.clamp(virtualPower, Redstone.SIGNAL_MIN, Redstone.SIGNAL_MAX);
+		state = state.set(currentPower);
+
+		return WorldHelper.setWireState(world, pos, state);
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
new file mode 100644
index 000000000..939a59990
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
@@ -0,0 +1,59 @@
+package net.minecraft.core.current.wire;
+
+import net.minecraft.core.current.util.BlockPos;
+import net.minecraft.core.current.util.BlockState;
+import net.minecraft.core.world.World;
+
+public class WorldHelper {
+
+	private static final int Y_MIN = 0;
+
+	static BlockState getBlockState(World world, BlockPos pos) {
+		if (pos.y < Y_MIN || pos.y >= world.getHeightBlocks()) {
+			return BlockState.AIR;
+		}
+
+		int blockId = world.getBlockId(pos.x, pos.y, pos.z);
+
+		if (blockId == 0) {
+			return BlockState.AIR;
+		}
+
+		return new BlockState(blockId, world.getBlockMetadata(pos.x, pos.y, pos.z));
+	}
+
+	/**
+	 * An optimized version of {@link net.minecraft.world.World#setBlockState
+	 * World.setBlockState}. Since this method is only used to update redstone wire block
+	 * states, lighting checks, height map updates, and block entity updates are
+	 * omitted.
+	 */
+	static boolean setWireState(World world, BlockPos pos, BlockState state) {
+		if (pos.y < Y_MIN || pos.y >= world.getHeightBlocks()) {
+			return false;
+		}
+
+		int blockId = state.getBlockId();
+		int prevBlockId = world.getBlockId(pos.x, pos.y, pos.z);
+
+		if (blockId != prevBlockId) {
+			return false;
+		}
+
+		int metadata = state.get();
+		int prevMetadata = world.getBlockMetadata(pos.x, pos.y, pos.z);
+
+		if (metadata == prevMetadata) {
+			return false;
+		}
+
+		world.setBlockMetadata(pos.x, pos.y, pos.z, metadata);
+
+		// notify clients of the BlockState change
+		world.notifyBlockChange(pos.x, pos.y, pos.z, blockId);
+		// mark the chunk for saving
+		world.markBlockDirty(pos.x, pos.y, pos.z);
+
+		return true;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index bfc8547ba..b88295fd0 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -94,6 +94,8 @@ public class Registries extends Registry<Registry<?>>
             List<ItemStack> woolStackList = new ArrayList<>();
             List<ItemStack> lampStackList = new ArrayList<>();
             List<ItemStack> invertedLampStackList = new ArrayList<>();
+            List<ItemStack> woodenButtonsList = new ArrayList<>();
+            List<ItemStack> woodenPressurePlatesList = new ArrayList<>();
 
             plankStackList.add(Blocks.PLANKS_OAK.getDefaultStack());
             signStackList.add(Items.SIGN.getDefaultStack());
@@ -104,6 +106,8 @@ public class Registries extends Registry<Registry<?>>
             fencesStackList.add(Blocks.FENCE_PLANKS_OAK.getDefaultStack());
             fenceGatesStackList.add(Blocks.FENCE_GATE_PLANKS_OAK.getDefaultStack());
             trapdoorStackList.add(Blocks.TRAPDOOR_PLANKS_OAK.getDefaultStack());
+            woodenButtonsList.add(Blocks.BUTTON_PLANKS.getDefaultStack());
+            woodenPressurePlatesList.add(Blocks.PRESSURE_PLATE_PLANKS_OAK.getDefaultStack());
 
             for (DyeColor color : DyeColor.values()) {
                 plankStackList.add(new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, color.blockMeta));
@@ -118,6 +122,8 @@ public class Registries extends Registry<Registry<?>>
                 woolStackList.add(new ItemStack(Blocks.WOOL, 1, color.blockMeta));
                 lampStackList.add(new ItemStack(Blocks.LAMP_IDLE, 1, color.blockMeta));
                 invertedLampStackList.add(new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, color.blockMeta));
+                woodenButtonsList.add(new ItemStack(Blocks.BUTTON_PLANKS_PAINTED, 1, color.blockMeta << 4));
+                woodenPressurePlatesList.add(new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
             }
             ITEM_GROUPS.register("minecraft:planks",plankStackList);
             ITEM_GROUPS.register("minecraft:signs",signStackList);
@@ -131,6 +137,8 @@ public class Registries extends Registry<Registry<?>>
             ITEM_GROUPS.register("minecraft:fences_planks", fencesStackList);
             ITEM_GROUPS.register("minecraft:fence_gates_planks", fenceGatesStackList);
             ITEM_GROUPS.register("minecraft:trapdoor_planks", trapdoorStackList);
+            ITEM_GROUPS.register("minecraft:button_planks", woodenButtonsList);
+            ITEM_GROUPS.register("minecraft:pressureplates_planks", woodenPressurePlatesList);
         }
 
         ITEM_GROUPS.register("minecraft:tool_swords",
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemCoal.java b/game/core/src/main/java/net/minecraft/core/item/ItemCoal.java
index 0382a6e3d..a9b471384 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemCoal.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemCoal.java
@@ -2,6 +2,8 @@ package net.minecraft.core.item;
 
 public class ItemCoal extends Item
 {
+    public static final int META_COAL = 0;
+    public static final int META_CHARCOAL = 1;
 
     public ItemCoal(String name, String namespaceId, int id)
     {
@@ -13,7 +15,7 @@ public class ItemCoal extends Item
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
-        if(itemstack.getMetadata() == 1)
+        if(itemstack.getMetadata() == META_CHARCOAL)
         {
             return "item.charcoal";
         } else
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
index 944f96407..d90b20728 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFarmland;
 import net.minecraft.core.block.Blocks;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
@@ -45,8 +46,9 @@ public class ItemSeeds extends Item {
 		int y = blockY + direction.getOffsetY();
 		int z = blockZ + direction.getOffsetZ();
 		Block<?> b = world.getBlock(x, y, z);
-		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-			onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
+		boolean isFarmland = Block.hasLogicClass(b, BlockLogicFarmland.class);
+		if (b == null || isFarmland || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+			onUseItemOnBlock(itemStack, null, world, x, y + (isFarmland ? 1 : 0), z, direction.getSide(), 0.5, 0.5);
 		}
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index 8edb31b85..fa8af726c 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -1,6 +1,9 @@
 package net.minecraft.core.player.inventory.menu;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.IPainted;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.item.ItemCoal;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Item;
@@ -9,6 +12,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.SlotCreative;
+import net.minecraft.core.util.helper.DyeColor;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -80,8 +84,9 @@ public class MenuInventoryCreative extends MenuInventory
 		searchedItems.clear();
 		page = 0;
 		I18n t = I18n.getInstance();
-		
-		for (int i = 0; i < creativeItemsCount; i++)
+
+		int itemsCount = creativeItems.size();
+		for (int i = 0; i < itemsCount; i++)
 		{
 			if (t.translateKey(creativeItems.get(i).getItemKey() + ".name").toLowerCase().contains(search.toLowerCase()))
 			{
@@ -123,71 +128,38 @@ public class MenuInventoryCreative extends MenuInventory
 	}
 	
 	public static List<ItemStack> creativeItems = new ArrayList<>();
-	public static int creativeItemsCount;
-	
+
 	static
 	{
-		int count = 0;
-		
-		for (int id = 0; id < Blocks.blocksList.length; id++)
-		{
-			if (Blocks.blocksList[id] != null && !Blocks.blocksList[id].hasTag(BlockTags.NOT_IN_CREATIVE_MENU))
-			{
-				creativeItems.add(new ItemStack(Blocks.blocksList[id]));
-				count++;
-				
-				if (id == Blocks.WOOL.id() || id == Blocks.PLANKS_OAK_PAINTED.id() || id == Blocks.LAMP_IDLE.id() || id == Blocks.LAMP_INVERTED_ACTIVE.id() || id == Blocks.FENCE_PLANKS_OAK_PAINTED.id())
-				{
-					for (int i = 1; i < 16; i++)
-					{
-						creativeItems.add(new ItemStack(Blocks.blocksList[id], 1, i));
-						count++;
-					}
-				}
-				else if (id == Blocks.CHEST_PLANKS_OAK_PAINTED.id() || id == Blocks.SLAB_PLANKS_PAINTED.id() || id == Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id()
-					  || id == Blocks.STAIRS_PLANKS_PAINTED.id() || id == Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id() || id == Blocks.DOOR_PLANKS_PAINTED_TOP.id()
-					  || id == Blocks.TRAPDOOR_PLANKS_PAINTED.id())
-				{
-					for (int i = 0x10; i < 0x100; i += 0x10)
-					{
-						creativeItems.add(new ItemStack(Blocks.blocksList[id], 1, i));
-						count++;
-					}
+		for (Block<?> block : Blocks.blocksList) {
+			if (block == null || block.hasTag(BlockTags.NOT_IN_CREATIVE_MENU)) continue;
+
+			if (Block.hasLogicClass(block, IPainted.class)) {
+				IPainted painted = (IPainted) block.getLogic();
+				for (DyeColor color : DyeColor.values()) {
+					creativeItems.add(new ItemStack(block, 1, painted.toMetadata(color)));
 				}
+			} else {
+				creativeItems.add(new ItemStack(block));
 			}
 		}
 		
 		for (int i = Blocks.blocksList.length; i < Item.itemsList.length; i++)
 		{
-			if (Item.itemsList[i] != null && !Item.itemsList[i].hasTag(ItemTags.NOT_IN_CREATIVE_MENU))
-			{
-				if (i == Items.PAINTBRUSH.id) {
-					creativeItems.add(new ItemStack(Item.itemsList[i], 1, Items.PAINTBRUSH.getMaxDamage()));
-				} else {
-					creativeItems.add(new ItemStack(Item.itemsList[i]));
-				}
-				count++;
-
-				if (i == Items.COAL.id)
-				{
-					for (int j = 1; j < 2; j++)
-					{
-						creativeItems.add(new ItemStack(Item.itemsList[i], 1, j));
-						count++;
-					}
-				}
-
-				if (i == Items.DYE.id || i == Items.DOOR_OAK_PAINTED.id || i == Items.SIGN_PAINTED.id)
-				{
-					for (int j = 1; j < 16; j++)
-					{
-						creativeItems.add(new ItemStack(Item.itemsList[i], 1, j));
-						count++;
-					}
+			Item item = Item.itemsList[i];
+			if (item == null || item.hasTag(ItemTags.NOT_IN_CREATIVE_MENU)) continue;
+			if (item == Items.PAINTBRUSH) {
+				creativeItems.add(new ItemStack(item, 1, Items.PAINTBRUSH.getMaxDamage()));
+			} else if (item == Items.COAL) {
+				creativeItems.add(new ItemStack(item, 1, ItemCoal.META_COAL));
+				creativeItems.add(new ItemStack(item, 1, ItemCoal.META_CHARCOAL));
+			} else if (item == Items.DYE || item == Items.DOOR_OAK_PAINTED || item == Items.SIGN_PAINTED) {
+				for (DyeColor color : DyeColor.values()) {
+					creativeItems.add(new ItemStack(item, 1, color.itemMeta));
 				}
+			} else {
+				creativeItems.add(new ItemStack(item));
 			}
 		}
-		
-		creativeItemsCount = count;
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index d6aec1900..129b38da5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -16,6 +16,7 @@ import com.mojang.nbt.tags.CompoundTag;
 
 import net.minecraft.core.block.BlockLogicOreRedstone;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.enums.Difficulty;
@@ -139,6 +140,7 @@ public class World implements WorldSource {
     public WeatherManager weatherManager;
 
     private CommandManager commandManager;
+    private final @NotNull WireHandler wireHandler;
 
     //Usually called when a world is loaded or generated (Singleplayer & Server)
     public World(LevelStorage saveHandler, String name, long seed, Dimension dimension, WorldType worldType)
@@ -228,6 +230,8 @@ public class World implements WorldSource {
 
         this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
+
+        this.wireHandler = new WireHandler(this);
     }
 
     //Usually called when going through portals
@@ -270,6 +274,8 @@ public class World implements WorldSource {
 
         this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
+
+        this.wireHandler = new WireHandler(this);
     }
 
     //Usually called when joining a server
@@ -293,9 +299,13 @@ public class World implements WorldSource {
 
         this.commandManager = new CommandManager(isServer);
         this.commandManager.init();
+
+        this.wireHandler = new WireHandler(this);
     }
 
-    public World(){}
+    public World(){
+        this.wireHandler = new WireHandler(this);
+    }
 
     public <T> T getGameRuleValue(GameRule<T> gameRule)
     {
@@ -320,6 +330,10 @@ public class World implements WorldSource {
         return commandManager;
     }
 
+    public @NotNull WireHandler getWireHandler() {
+        return this.wireHandler;
+    }
+
     protected IChunkProvider createChunkProvider()
     {
         IChunkLoader chunkLoader = saveHandler.getChunkLoader(dimension);
@@ -2647,15 +2661,31 @@ public class World implements WorldSource {
 
     public boolean getSignal(int x, int y, int z, Side side) {
         Block<?> block = getBlock(x, y, z);
-        if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE && !Block.hasLogicClass(block, BlockLogicOreRedstone.class) && block != Blocks.PUMPKIN_REDSTONE) {
+        if(isBlockNormalCube(x, y, z) && block != Blocks.BLOCK_REDSTONE  && block != Blocks.PUMPKIN_REDSTONE) {
             return hasDirectSignal(x, y, z);
         }
         if(block == null) {
             return false;
         }
 
-        return block.getSignal(this, x, y, z, side);
+        if (block == Blocks.PUMPKIN_REDSTONE) { // TODO make actual block methods to handle sided-ness
+            return pumpkinHasDirectSignal(x, y, z) || block.getSignal(this, x, y, z, side);
+        } else {
+            return block.getSignal(this, x, y, z, side);
+        }
     }
+    // Special version of hasDirectSignal that excludes the front side of the redstone lantern.
+    private boolean pumpkinHasDirectSignal(int x, int y, int z) {
+        for (Side side : Side.sides) {
+            if(Side.getSideById(getBlockMetadata(x, y, z)) == side) continue;
+            if (getDirectSignal(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side)) {
+                return true;
+            }
+        }
+
+        return false;
+    }
+
 
     public boolean hasNeighborSignal(int x, int y, int z) {
         for (Side side : Side.sides){
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index f85f82a36..316facd76 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -128,10 +128,13 @@ options.bloom=Bloom
 options.bloom.low=Low
 options.bloom.high=High
 options.renderScale=Render Scale
+options.renderScale.scale_0625=0.0625x
+options.renderScale.scale_125=0.125x
 options.renderScale.scale_25=0.25x
 options.renderScale.scale_50=0.5x
 options.renderScale.scale_100=1x
 options.renderScale.scale_200=2x
+options.renderScale.scale_400=4x
 options.heatHaze=Heat Haze
 options.showCollisionBoxes=Show Collision Boxes
 options.showDebugScreen=Show Debug Screen
diff --git a/game/core/src/main/resources/lang/en_US/tile.lang b/game/core/src/main/resources/lang/en_US/tile.lang
index 632881212..14952b2b0 100644
--- a/game/core/src/main/resources/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/lang/en_US/tile.lang
@@ -672,8 +672,45 @@ tile.torch.redstone.idle.desc=Emits a constant redstone signal.
 tile.torch.redstone.active.name=Redstone Torch
 tile.torch.redstone.active.desc=Emits a constant redstone signal.
 
-tile.button.stone.name=Button
+tile.button.stone.name=Stone Button
 tile.button.stone.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.name=Wooden Button
+tile.button.planks.desc=Emits a brief redstone signal when pressed.
+
+tile.button.planks.painted.name=Mystery Button
+tile.button.planks.painted.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.black.name=Black Wooden Button
+tile.button.planks.painted.black.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.red.name=Red Wooden Button
+tile.button.planks.painted.red.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.green.name=Green Wooden Button
+tile.button.planks.painted.green.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.brown.name=Brown Wooden Button
+tile.button.planks.painted.brown.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.blue.name=Blue Wooden Button
+tile.button.planks.painted.blue.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.purple.name=Purple Wooden Button
+tile.button.planks.painted.purple.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.cyan.name=Cyan Wooden Button
+tile.button.planks.painted.cyan.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.silver.name=Light Gray Wooden Button
+tile.button.planks.painted.silver.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.gray.name=Gray Wooden Button
+tile.button.planks.painted.gray.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.pink.name=Pink Wooden Button
+tile.button.planks.painted.pink.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.lime.name=Lime Wooden Button
+tile.button.planks.painted.lime.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.yellow.name=Yellow Wooden Button
+tile.button.planks.painted.yellow.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.lightblue.name=Light Blue Wooden Button
+tile.button.planks.painted.lightblue.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.magenta.name=Magenta Wooden Button
+tile.button.planks.painted.magenta.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.orange.name=Orange Wooden Button
+tile.button.planks.painted.orange.desc=Emits a brief redstone signal when pressed.
+tile.button.planks.painted.white.name=White Wooden Button
+tile.button.planks.painted.white.desc=Emits a brief redstone signal when pressed.
 
 tile.lever.cobble.stone.name=Lever
 tile.lever.cobble.stone.desc=Allows turning a redstone signal on or off.
@@ -685,6 +722,41 @@ tile.pressureplate.planks.oak.desc=Emits a redstone signal when anything steps o
 tile.pressureplate.cobble.stone.name=Cobblestone Pressure Plate
 tile.pressureplate.cobble.stone.desc=Emits a redstone signal when players step on it.
 
+tile.pressureplate.planks.oak.painted.name=Mystery Wooden Plate
+tile.pressureplate.planks.oak.painted.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.black.name=Black Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.black.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.red.name=Red Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.red.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.green.name=Green Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.green.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.brown.name=Brown Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.brown.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.blue.name=Blue Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.blue.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.purple.name=Purple Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.purple.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.cyan.name=Cyan Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.cyan.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.silver.name=Light Gray Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.silver.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.gray.name=Gray Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.gray.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.pink.name=Pink Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.pink.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.lime.name=Lime Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.lime.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.yellow.name=Yellow Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.yellow.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.lightblue.name=Light Blue Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.lightblue.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.magenta.name=Magenta Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.magenta.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.orange.name=Orange Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.orange.desc=Emits a redstone signal when anything steps on it.
+tile.pressureplate.planks.oak.painted.white.name=White Wooden Pressure Plate
+tile.pressureplate.planks.oak.painted.white.desc=Emits a redstone signal when anything steps on it.
+
 tile.motionsensor.idle.name=Motion Sensor
 tile.motionsensor.idle.desc=Emits a redstone signal when something moves past it.
 tile.motionsensor.active.name=Active Motion Sensor
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 0482f3a12..d9c3fbbea 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1169,8 +1169,11 @@ class WorkbenchGenerator {
         RecipeBuilderShaped plate = RecipeBuilder.Shaped(CORE_NAMESPACE).setShape("##");
 
         plate.addInput('#', Blocks.STONE).create("stone_pressure_plate", Blocks.PRESSURE_PLATE_STONE.getDefaultStack());
-        plate.addInput('#', "minecraft:planks").create("wooden_pressure_plate", Blocks.PRESSURE_PLATE_PLANKS_OAK.getDefaultStack());
+        plate.addInput('#', Blocks.PLANKS_OAK).create("wooden_pressure_plate", Blocks.PRESSURE_PLATE_PLANKS_OAK.getDefaultStack());
         plate.addInput('#', "minecraft:cobblestones").create("cobblestone_pressure_plate", Blocks.PRESSURE_PLATE_COBBLE_STONE.getDefaultStack());
+        for (DyeColor color : DyeColor.values()) {
+            plate.addInput('#', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID +  "_wooden_pressure_plate", new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
+        }
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1221,6 +1224,10 @@ class WorkbenchGenerator {
             .create("tnt", new ItemStack(Blocks.TNT));
 
         RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput("minecraft:stones").create("stone_button", new ItemStack(Blocks.BUTTON_STONE, 4));
+        RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.PLANKS_OAK).create("wooden_button", new ItemStack(Blocks.BUTTON_PLANKS, 4));
+        for (DyeColor color : DyeColor.values()) {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE).addInput(Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_wooden_button", new ItemStack(Blocks.BUTTON_PLANKS_PAINTED, 4, color.blockMeta << 4));
+        }
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1344,6 +1351,8 @@ class WorkbenchGenerator {
         Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "button_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:button_planks"), new ItemStack(Blocks.BUTTON_PLANKS)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "pressureplates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:pressureplates_planks"), new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK)));
     }
 
     private static void generateStatueRecipes() {
